# clients_xtrap.mms (XTrap clients/xtrap MM rfile)
#
#
TCPCONN        = 1                      ! yes,  build with TCP/IP
# DW_V3 = 1                             ! this is VMS DECwindows Vers 3

# The following logicals must be defined or these macros overriden
EXTDIR          = xtrap$ext:            ! external stuff to link with
USRBIN          = xtrap$bin:            ! where to install images
USRLIB          = xtrap$lib:            ! where to install libraries
USRINCLUDE      = xtrap$include:        ! where to install includes
#
X11             = decw$include:
SYS             = sys$library:
SRCBIN          = sys$disk:[]
SRCLIB          = sys$disk:[]
LIBXTRAP       = $(USRLIB)libXTrap.olb
OPT            = $(SRCLIB)libXTrap.opt
IDIRS           = /include=(sys$disk:[],$(X11),$(SYS))
.ifdef TCPCONN
DEFINES         = /define=(MBXCONN,DNETCONN,TCPCONN,VERBOSE)
.else
DEFINES         = /define=(MBXCONN,DNETCONN,VERBOSE)
.endif
CCOPTS          = /noopt/debug
CFLAGS          = $(IDIRS)$(CCOPTS)/list=$(SRCLIB)/obj=$(SRCLIB) $(DEFINES)
LDFLAGS         =
ECHO            = write sys$output
RM              = delete/noconfirm/log
AR              = library/replace
CP              = copy/log

INCLUDES = xtrapdi.h, xtraplibproto.h, xtraplib.h, \
           bits.h, xestream.h, xemacros.h

PROGS = XTrapReset.exe,XTrapInfo.exe,XTrapStats.exe,XTrapOut.exe,XTrapIn.exe

all : $(PROGS)
    $(ECHO) "Build Completed."

$(OPT) : clients_xtrap.mms
        open/write fhdl $@
        write fhdl "ident=XTrap V3.1, VMS V5.4"
.IFDEF DW_V3
        write fhdl "$(EXTDIR)decw$xtshr.exe/share"
.ELSE
        write fhdl "$(EXTDIR)decw$dwtlibshr.exe/share"
.ENDIF
        write fhdl "$(EXTDIR)decw$xlibshr.exe/share"
        write fhdl "$(EXTDIR)vaxcrtl.exe/share"
        write fhdl "$(EXTDIR)mthrtl.exe/share"
        write fhdl "$(EXTDIR)librtl.exe/share"
.IFDEF TCPCONN
        write fhdl "$(EXTDIR)ucx$ipc.olb/lib"
.ENDIF
        write fhdl "$(EXTDIR)sys.stb/selective"
        close fhdl


XTrapReset.exe : $(SRCLIB)XTrapReset.obj $(LIBXTRAP) $(OPT)
    $(LINK) /exe=$(SRCBIN) $(LDFLAGS) $(SRCLIB)XTrapReset, \
        $(LIBXTRAP)/lib, $(OPT)/opt 

XTrapInfo.exe : $(SRCLIB)XTrapInfo.obj $(LIBXTRAP) $(OPT)
    $(LINK) /exe=$(SRCBIN) $(LDFLAGS) $(SRCLIB)XTrapInfo, \
        $(LIBXTRAP)/lib, $(OPT)/opt 
    $(LINK) /exe=$(SRCBIN)XTrapInfoDbg.exe $(LDFLAGS)/deb $(SRCLIB)XTrapInfo, \
        $(LIBXTRAP)/lib, $(OPT)/opt 

XTrapStats.exe : $(SRCLIB)XTrapStats.obj $(LIBXTRAP) $(OPT)
    $(LINK) /exe=$(SRCBIN) $(LDFLAGS) $(SRCLIB)XTrapStats, \
        $(LIBXTRAP)/lib, $(OPT)/opt 
    $(LINK) /exe=$(SRCBIN)XTrapStatsDbg.exe $(LDFLAGS)/deb \
        $(SRCLIB)XTrapStats, $(LIBXTRAP)/lib, $(OPT)/opt 

XTrapOut.exe : $(SRCLIB)XTrapOut.obj $(LIBXTRAP) $(OPT)
    $(LINK) /exe=$(SRCBIN) $(LDFLAGS) $(SRCLIB)XTrapOut, \
        $(LIBXTRAP)/lib, $(OPT)/opt 
    $(LINK) /exe=$(SRCBIN)XTrapOutDbg.exe $(LDFLAGS)/deb $(SRCLIB)XTrapOut, \
        $(LIBXTRAP)/lib, $(OPT)/opt

XTrapIn.exe : $(SRCLIB)XTrapIn.obj $(LIBXTRAP) $(OPT)
    $(LINK) /exe=$(SRCBIN) $(LDFLAGS) $(SRCLIB)XTrapIn, \
        $(LIBXTRAP)/lib, $(OPT)/opt 
    $(LINK) /exe=$(SRCBIN)XTrapInDbg.exe $(LDFLAGS)/deb $(SRCLIB)XTrapIn, \
        $(LIBXTRAP)/lib, $(OPT)/opt

clean :  
    $(RM) $(SRCLIB)*.obj;*, *.lis;*, $(OPT);*, $(SRCBIN)*.EXE;*

install :    
    $(CP) $(SRCBIN)$(PROGS) $(USRBIN)

# Module Dependencies
$(SRCLIB)XTrapReset.obj : XTrapReset.c, $(INCLUDES)
$(SRCLIB)XTrapInfo.obj  : XTrapInfo.c,  $(INCLUDES)
$(SRCLIB)XTrapStats.obj : XTrapStats.c, $(INCLUDES)
$(SRCLIB)XTrapOut.obj   : XTrapOut.c,   $(INCLUDES)
$(SRCLIB)XTrapIn.obj    : XTrapIn.c,   $(INCLUDES)


