# ext_server.mms (XTrap extensions/server MMS file)
#
TCPCONN        = 1                      ! yes,  build with TCP/IP
# XTRAP_V21    = 1                      ! yes, do V2.1 build, not V3.0
# DW_V3 = 1                             ! this is VMS DECwindows Vers 3

# The following logicals must be defined or these macros overriden
SRV             = xtrap$srvincl:        ! server header files
EXTDIR          = xtrap$ext:            ! external stuff to link with
USRBIN          = xtrap$bin:            ! where to install images
USRLIB          = xtrap$lib:            ! where to install libraries
USRINCLUDE      = xtrap$include:        ! where to install includes
#
X11             = decw$include:
SYS             = sys$library:
SRCBIN          = []
SRCLIB          = []
.ifdef XTRAP_V21
LIB             = $(SRCLIB)XTrapV21.olb
OPT             = $(SRCLIB)XTrapV21.opt
.else
LIB             = $(SRCLIB)XTrap.olb
OPT             = $(SRCLIB)XTrap.opt
.endif
IDIRS           = /include=(sys$disk:[],$(SRV),$(X11),$(SYS))
.ifdef TCPCONN
.ifdef DW_V3
DEFINES         = /define=(MBXCONN,DNETCONN,TCPCONN,VMSDW_V3,VERBOSE)
.else
DEFINES         = /define=(MBXCONN,DNETCONN,TCPCONN,VERBOSE)
.endif
.else
.ifdef DW_V3
DEFINES         = /define=(MBXCONN,DNETCONN,VMSDW_V3,VERBOSE)
.else
DEFINES         = /define=(MBXCONN,DNETCONN,VERBOSE)
.endif
.endif
CCOPTS          = /noopt/debug
CFLAGS          = $(IDIRS)$(CCOPTS)/list=$(SRCLIB)/obj=$(SRCLIB) $(DEFINES)
LDFLAGS         =
ECHO            = write sys$output
RM              = delete/noconfirm/log
AR              = library/replace
CP              = copy/log


.ifdef XTRAP_V21
# These are lists of all the old source files (Version 2.1)
XTRAPOBJLIB=                                                 \
    $(LIB)(                                                  \
    xtrap=$(SRCLIB)xtrap.obj,                                \
    xtrap_procvectors=$(SRCLIB)xtrap_procvectors.obj,        \
    xtrap_procs=$(SRCLIB)xtrap_procs.obj,                    \
    xtrap_vms_io=$(SRCLIB)xtrap_vms_io.obj,                  \
    xtrap_vms_procs=$(SRCLIB)xtrap_vms_procs.obj,            \
    xtrapddvmssim=$(SRCLIB)xtrapddvmssim.obj )

PROGS = decw$server_extension_xtrap.exe, decw$server_extension_xtrapdbg.exe

INCLUDES = xtrap.h, xtrap_server.h, xtrap_vms.h, xtrap_vms_io.h

.else
# These are lists of all the new source files (Version 3.0)
XTRAPOBJLIB=                                                \
    $(LIB)(                                                 \
    xtrapddvmsxfer=$(SRCLIB)xtrapddvmsxfer.obj,             \
    xtrapdi=$(SRCLIB)xtrapdi.obj,                           \
    xtrapdiswap=$(SRCLIB)xtrapdiswap.obj,                   \
    xtrapditables=$(SRCLIB)xtrapditables.obj,               \
    xtrapddmi=$(SRCLIB)xtrapddmi.obj,                       \
    xtrapddvms=$(SRCLIB)xtrapddvms.obj,                     \
    xtrapddvmssim=$(SRCLIB)xtrapddvmssim.obj )

PROGS =    decw$svext_dec_xtrap.exe, decw$svext_dec_xtrapdbg.exe

INCLUDES = xtrapdi.h,   xtrapproto.h, bits.h, xtrapddmi.h
.endif

all :    $(PROGS)
    $(ECHO) "Build complete."


$(LIB) : $(XTRAPOBJLIB)
     $(ECHO) "Library $(LIB) is complete."


$(OPT) : ext_server.mms
    open/write fhdl $@
.ifdef XTRAP_V21
    write fhdl "ident=XTrap V2.1, VMS V5.4"
.else
    write fhdl "ident=XTrap V3.1, VMS V5.4"
.endif
    write fhdl "$(EXTDIR)decw$server_dix.exe/share"
    write fhdl "$(EXTDIR)decw$transport_common.exe/share"
.ifdef TCPCONN
        write fhdl "$(EXTDIR)ucx$ipc.olb/lib"
.endif
    write fhdl "$(EXTDIR)vaxcrtl.exe/share"
    write fhdl "$(EXTDIR)mthrtl.exe/share"
    write fhdl "$(EXTDIR)librtl.exe/share"
    write fhdl "GSMATCH = EQUAL,1,1000"
.ifdef XTRAP_V21
    write fhdl "UNIVERSAL = XtrapInit"
.else
    write fhdl "CLUSTER=XFR_VECTORS"
    write fhdl "COLLECT=XFR_VECTORS,$$VECTOR_0"
    write fhdl "SYMBOL=decw$debug_mismatch,1"
    write fhdl "SYMBOL=sp_enabled_mismatch,1"
.endif
    write fhdl "PSECT_ATTR= procvector,noshr"
    write fhdl "PSECT_ATTR= swappedprocvector,noshr"
    write fhdl "PSECT_ATTR= globalserialnumber,noshr"
    write fhdl "PSECT_ATTR= rootcursor,noshr"
    write fhdl "PSECT_ATTR= clients,noshr"
    write fhdl "PSECT_ATTR= serverclient,noshr"
    write fhdl "PSECT_ATTR= currenttime,noshr"
    write fhdl "PSECT_ATTR= defaultkeyboardcontrol,noshr"
    write fhdl "PSECT_ATTR= defaultpointercontrol,noshr" 
    write fhdl "PSECT_ATTR= input_headers,noshr"
    write fhdl "PSECT_ATTR= screeninfo,noshr"
    write fhdl "PSECT_ATTR= pixmapwidthpaddinginfo,noshr"
    write fhdl "PSECT_ATTR= replyswapvector,noshr"
    write fhdl "PSECT_ATTR= eventswapvector,noshr"
    write fhdl "PSECT_ATTR= xetrapioconf,noshr"
    write fhdl "PSECT_ATTR= xetrapkbddev,noshr"
    write fhdl "PSECT_ATTR= xetrapptrdev,noshr"
    write fhdl "PSECT_ATTR= xetraperrorbase,noshr"
    write fhdl "PSECT_ATTR= xetrap_avail,noshr" 
    write fhdl "PSECT_ATTR= dfd,noshr" 
    close fhdl

.ifdef XTRAP_V21
decw$server_extension_xtrap.exe : $(LIB) $(OPT)
    $(LINK) /EXE=$(SRCBIN)$@ /SHARE /NODEBUG /NOTRACE /map=$(SRCLIB)/full -
        $(LIB)/lib/include=(xtrap), $(OPT)/OPTIONS

decw$server_extension_xtrapdbg.exe : $(LIB) $(OPT)
    $(LINK) /EXE=$(SRCBIN)$@ /SHARE /DEBUG -
        $(LIB)/lib/include=(xtrap), $(OPT)/OPTIONS

.else

decw$svext_dec_xtrap.exe : $(LIB) $(OPT)
    $(LINK) /share=$(SRCBIN)$@ /NODEBUG /NOTRACE /map=$(SRCLIB)/full -
        $(LIB)/lib/include=(xtrapddvmsxfer), $(OPT)/OPTIONS

decw$svext_dec_xtrapdbg.exe : $(LIB) $(OPT)
    $(LINK) /share=$(SRCBIN)$@ /DEBUG -
        $(LIB)/lib/include=(xtrapddvmsxfer), $(OPT)/OPTIONS

.endif

clean :    
    $(RM) $(OPT);*, $(LIB);*, $(SRCLIB)*.obj;*, *.lis;*, *.map;*, \
        $(SRCBIN)decw$svext_dec_xtrap*.*;*

install :    
    $(CP) $(SRCBIN)$(PROGS) $(USRLIB)
    $(CP) $(SRCBIN)$(PROGS) $(USRLIB)
    $(CP) $(LIB) $(USRLIB)
    $(CP) $(OPT) $(USRLIB)
    $(CP) $(INCLUDES) $(USRINCLUDE)

# XTrap Module Dependencies

.ifdef XTRAP_V21

$(SRCLIB)xtrap.obj : xtrap.c xtrap.h xtrap_server.h

$(SRCLIB)xtrap_procvectors.obj : \
        xtrap_procvectors.c xtrap.h xtrap_server.h

$(SRCLIB)xtrap_procs.obj : xtrap_procs.c \
    xtrap.h xtrap_server.h

$(SRCLIB)xtrap_vms_procs.obj : xtrap_vms_procs.c \
    xtrap.h xtrap_server.h xtrap_vms.h xtrap_vms_io.h

$(SRCLIB)xtrap_vms_io.obj : xtrap_vms_io.c \
    xtrap.h xtrap_server.h xtrap_vms.h xtrap_vms_io.h

.else

# XTrap V3.0 Dependencies

$(SRCLIB)xtrapddvmsxfer.obj : xtrapddvmsxfer.mar

$(SRCLIB)xtrapdi.obj : xtrapdi.c \
        xtrapdi.h xtrapproto.h bits.h xtrapddmi.h

$(SRCLIB)xtrapdiswap.obj : xtrapdiswap.c \
        xtrapdi.h xtrapproto.h bits.h xtrapddmi.h

$(SRCLIB)xtrapditables.obj : xtrapditables.c \
        xtrapdi.h xtrapproto.h bits.h xtrapddmi.h

$(SRCLIB)xtrapddmi.obj : xtrapddmi.c \
        xtrapdi.h  xtrapproto.h xtrapddmi.h bits.h

$(SRCLIB)xtrapddvms.obj : xtrapddvms.c \
        xtrapdi.h  xtrapproto.h xtrapddmi.h bits.h

.endif

$(SRCLIB)xtrapddvmssim.obj : xtrapddvmssim.c




